/*
NAME: Ivan Anev
SCHOOL: SMG
PROGRAM: points
*/

#include <stdio.h>
#include <math.h>

#define MAXV 1024
#define MAXE 2097152

typedef struct Vex TVex;
typedef struct Edge TEdge;

struct Vex {
       int v, edges;
       double x, y;
};

struct Edge {
       int v, next;
};

TVex vs[MAXV];
TEdge es[MAXE];
int n, ne;
double eps = 0.0000001;

void dfs(int v) {
     int e;

     vs[v].v = 1;
     for (e = vs[v].edges; e != -1; e = es[e].next)
         if (vs[es[e].v].v == 0)
            dfs(es[e].v);
}

void init (int v) {
     int i;

     n = v;
     ne = 0;
     for (i = 0; i < v; ++i) {
         vs[i].v = 0;
         vs[i].edges = -1;
     }
}

double sqr(double x) {
       return x * x;
}

double dist(int i, int j) {
       return sqrt(sqr(vs[i].x - vs[j].x) + sqr(vs[i].y - vs[j].y));
}

void add_edge(int i, int j) {
     es[ne].v = j;
     es[ne].next = vs[i].edges;
     vs[i].edges = ne;
     ne++;
}

int main(void) {
    FILE *fin, *fout;
    int v, i, j, c;
    double d;

    fin = fopen("points.inp", "r");
    fout = fopen("points.out", "w");

    while (1) {
          fscanf(fin, "%d", &v);
          if (v == 0)
             break;
          init(v);
          fscanf(fin, "%lf", &d);
          for (i = 0; i < v; ++i) {
              fscanf(fin, "%lf %lf", &vs[i].x, &vs[i].y);
              for (j = 0; j < i; ++j)
                  if (d - dist(i, j) >= -eps) {
                     add_edge(i, j);
                     add_edge(j, i);
                  }
          }
          c = 0;
          for (i = 0; i < v; ++i)
              if (vs[i].v == 0) {
                 c++;
                 dfs(i);
              }
          fprintf(fout, "%d\n", c);
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
