{$MODE objfpc}

Type
  Float = Extended;
  TPoint = Record
    X, Y : Float;
  End;
  PElem = ^TElem;
  TElem = Record
    E : Integer;
    next : PElem;
  End;
  TChain = Record
    ChStart, ChEnd : PElem;
  End;

Var
  InF, OutF : Text;
  N : Integer;
  D, DSquared : Float;
  point : Array[0..1001] Of TPoint;
  chain : Array[0..1002] Of TChain;

Function DistGreater(p1, p2 : Integer) : Boolean;

Begin
{  Writeln(p1, ' ', p2);}
  DistGreater := (Sqr(point[p1].X - point[p2].X) + Sqr(point[p1].Y - point[p2].Y)) > DSquared;
End;

Procedure FlushChains;

Var
  I : Integer;
  p, tmp : PElem;

Begin
  For I := 1 To 1002 Do
  Begin
    p := chain[I].ChStart;
    While p <> Nil Do
    Begin
      tmp := p^.next;
      Dispose(p);
      p := tmp;
    End;
    chain[I].ChStart := Nil;
    chain[I].ChEnd := Nil;
  End;
End;

Procedure Bahur;

Var
  I, J : Integer;
  p : PElem;
  combine : Boolean;
  res : Integer;

Begin
  DSquared := D * D;
  FlushChains;
  res := 0;
  For I := 1 To N Do
  Begin
    Inc(res);
    New(chain[I].ChStart);
    chain[I].ChEnd := chain[I].ChStart;
    chain[I].ChStart^.next := Nil;
    chain[I].ChStart^.E := I;
    For J := 1 To I - 1 Do
    Begin
      p := chain[J].ChStart;
      combine := False;
      While p <> Nil Do
      Begin
        If Not DistGreater(I, p^.E) Then
        Begin
          combine := True;
          p := Nil;
        End
        Else
          p := p^.next;
      End;
      If combine Then
      Begin
{        Writeln('combo', I, '<-', J);}
        chain[I].ChEnd^.next := chain[J].ChStart;
        chain[I].ChEnd := chain[J].ChEnd;
        chain[J].ChStart := Nil;
        chain[J].ChEnd := Nil;
        Dec(res);
      End;
    End;
  End;
  Writeln(OutF, res);
End;

Var
  I : Integer;

Begin
  FillChar(chain, SizeOf(chain), 0);
  ASSign(InF, 'points.inp');
  Reset(InF);
  ASSign(OutF, 'points.out');
  Rewrite(OutF);
  Repeat
    Read(InF, N);
    If N <> 0 Then
    Begin
      Read(InF, D);
      For I := 1 To N Do
        Read(InF, point[I].X, point[I].Y);
      Bahur;
    End;
  Until N = 0;
  Close(InF);
  Close(OutF);
End.
