#include <fstream>
#include <cstring>

//#define DYN

ifstream fin("points.inp");
ofstream fout("points.out");

struct point {
  double x,y;
};


int n;
#ifdef DYN
point *p;
int *l[1024];
#else
point p[1024];
int l[1024][1024];
#endif
char m[1024];
double d;
int r;


double dist(point a,point b)
{
  double dx=a.x-b.x;
  double dy=a.y-b.y;
  return dx*dx+dy*dy;
}


void dfs(int u)
{
  m[u]=1;
  for (int i=1;i<=l[u][0];i++)
    if (m[l[u][i]]==0) dfs(l[u][i]);
}


int main()
{
#ifdef DYN
  p=new point[1024];
  for (int i=0;i<1024;i++) l[i]=new int[1024];
#endif

  fin >> n;
  while (n)
  {
    fin >> d;
    for (int i=0;i<n;i++) fin >> p[i].x >> p[i].y;
    d=d*d;

    memset(l,0,sizeof(l));
    for (int i=0;i<n;i++)
      for (int j=i+1;j<n;j++)
        if (dist(p[i],p[j])<=d)
        {
          l[i][++l[i][0]]=j;
          l[j][++l[j][0]]=i;
        }

    memset(m,0,sizeof(m));
    r=0;
    for (int i=0;i<n;i++)
      if (m[i]==0)
      {
        r++;
        dfs(i);
      }

    fout << r << endl;

    fin >> n;
  }

#ifdef DYN
  delete p;
  for (int i=0;i<1024;i++) delete l[i];
#endif

  return 0;
}
