#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXN 1024
#define EPS (1e-13)


int N;
double D;
int P;

int g[MAXN][MAXN];
double p[MAXN][2];
int deg[MAXN];
int comp[MAXN];
int ncomp;


FILE *fin, *fout;


int read_all(void);
void do_all(void);
void DFS(int u);
void write_all(void);




int main(void)
{
  fin  = fopen("points.inp", "rt");
  fout = fopen("points.out", "wt");
  while (read_all()) {
    do_all();
    write_all();
  }
  return 0;
}




int read_all(void)
{
  int i;

  if (fscanf(fin, "%d", &N) != 1)  return 0;
  if (N <= 0)  return 0;
  if (fscanf(fin, "%lf", &D) != 1)  return 0;
  for (i = 0; i < N; i++) {
    fscanf(fin, "%lf %lf", &p[i][0], &p[i][1]);
  }
  return 1;
}




void do_all(void)
{
  int i, j;
  double dist;

  memset(deg, 0, sizeof(deg));
  memset(comp, 0, sizeof(comp));
  for (i = 0; i < N; i++) {
    for (j = i+1; j < N; j++) {
      dist = hypot(p[i][0]-p[j][0], p[i][1]-p[j][1]);
      if (dist - D <= EPS) {
        g[i][deg[i]++] = j;
        g[j][deg[j]++] = i;
      }
    }
  }
  ncomp = 1;
  for (i = 0; i < N; i++) {
    if (comp[i] > 0)  continue;
    DFS(i);
    ncomp++;
  }
  P = ncomp-1;
}




void DFS(int u)
{
  int i;

  comp[u] = ncomp;
  for (i = 0; i < deg[u]; i++) {
    if (comp[g[u][i]] == 0) {
      DFS(g[u][i]);
    }
  }
}



void write_all(void)
{
  fprintf(fout, "%d\n", P);
}

