#include <stdio.h>
#include <string.h>
#define INPF "hill.inp"
#define OUTF "hill.out"
#define MAXN 1050
#define MAX(a,b) ((a)>(b)?(a):(b))
#define INF 100000000

struct Reb { int a,b;} rbs[100050];

float gr[2*MAXN+2][2*MAXN+2];
float res=0;

int m,n,a,b;

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    int p;
    fscanf(f,"%d%d",&n,&m);
    for(int i=0;i<=n;i++)for(int j=0;j<=n;j++) gr[i][j]=INF;
    for(int i=0;i<m;i++)
      {
        fscanf(f,"%d %d %d",&rbs[i].a,&rbs[i].b,&p);
        gr[rbs[i].a][rbs[i].b]=gr[rbs[i].b][rbs[i].a]=p;
      }
    fscanf(f,"%d%d",&a,&b);
    fclose(f);
  }

void Solve()
  {
    float dist[MAXN],inr[MAXN];
    int parent[MAXN],used[MAXN],min;
    memset(used,0,sizeof(used));
    memset(parent,0,sizeof(parent));
    memset(inr,0,sizeof(used));
    for(int i=0;i<=n;i++) dist[i]=INF;
    dist[a]=0;    
    while(1)
      {
        min=0;
        for(int i=1;i<=n;i++)if(!used[i] && (dist[i]<dist[min] || (dist[i]==dist[min] && inr[i]>inr[min]))) min=i;
        if(!min) break;
        used[min]=1;
        for(int i=1;i<=n;i++)
          if(gr[min][i]!=INF && dist[i]>dist[min]+MAX(gr[min][i]/2-inr[min],0))
            {
              dist[i]=dist[min]+MAX(gr[min][i]/2-inr[min],0);
              inr[i]=gr[min][i]/4;
              parent[i]=min;
            }
      }
    if(dist[b]==INF) res=0;
                else res=dist[b];
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    if(res!=0) fprintf(f,"%0.2f\n",res);
          else fprintf(f,"0\n",res);
    fclose(f);
  }

void main()
  {
    Init();
    Solve();
    Output();
  }
