{$MODE objfpc}

Uses
  HillBugU;

Type
  Float = Double;
  TEV = Record
    A, B : Integer;
  End;

Var
  M, N : Integer;
  G2 : Array[0..100000] Of TEV;
  G2Num : Integer;
  P : Array[0..100000] Of Float;
  V : Array[0..100000] Of Boolean;

  GG : Array[0..1023, 0..1023] Of Integer;
  GGG : Array[0..1023, 0..1023] Of Integer;
  G : Array[0..1023, 0..1023] Of Record
    V : Integer;
    L : Integer;
  End;
  GNN : Array[0..1023] Of Integer;

  Source, Dest : Integer;

Procedure TestP(Q : Integer);

Var
  I : Integer;

Begin
  If V[Q] Then
    Exit;
  V[Q] := True;
  For I := 1 To GNN[Q] Do
    TestP(G[Q, I].V);
End;

Procedure Swap(Var a, b : Integer);

Var
  tmp : Integer;

Begin
  tmp := a;
  a := b;
  b := tmp;
End;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'HILL.OUT');
  Rewrite(F);
  Writeln(F, 0);
  Close(F);
  Halt;
End;

Procedure WriteOut(q : Float);

Var
  F : Text;

Begin
  ASSign(F, 'HILL.OUT');
  Rewrite(F);
  Writeln(F, q:0:2);
  Close(F);
  Halt;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;
  A, B, C : Integer;

Begin
{  FillChar(G, SizeOf(G), $3F);}
  FillChar(GNN, SizeOf(GNN), 0);
  ASSign(F, 'HILL.INP');
  Reset(F);
  Readln(F, N, M);
  G2Num := 0;
  For I := 1 To M Do
  Begin
    Readln(F, A, B, C);
    GG[A, B] := C;
    GG[B, A] := C;

    Inc(GNN[A]);
    G[A, GNN[A]].V := B;
    G[A, GNN[A]].L := C;
    Inc(GNN[B]);
    G[B, GNN[B]].V := A;
    G[B, GNN[B]].L := C;

    If A > B Then
      Swap(A, B);
    Inc(G2Num);
    G2[G2Num].A := A;
    G2[G2Num].B := B;

    GGG[A, B] := G2Num;
    GGG[B, A] := G2Num;
  End;
  Readln(F, Source, Dest);
  Close(F);
End;

Function Clip(q : Float) : Float;

Begin
  If q > 0 Then
    Clip := q
  Else
    Clip := 0;
End;

Function Edge(V1, V2 : Integer) : Float;

Var
  V1A, V1B, V2A, V2B : Integer;
  l1, l2 : Float;

Begin
  V1A := G2[V1].A;
  V1B := G2[V1].B;
  V2A := G2[V2].A;
  V2B := G2[V2].B;
  If (V1A = V2A) And (V1B = V2B) Then
  Begin
    l1 := GG[V1B, V1A];
    l2 := GG[V2A, V2B];
    Edge := Clip((l2/2) - (l1/4));
    Exit;
  End;
  If V1A = V2A Then
  Else
    If V1B = V2B Then
    Begin
      Swap(V1A, V1B);
      Swap(V2A, V2B);
    End
    Else
      If V1A = V2B Then
        Swap(V2A, V2B)
      Else
        If V1B = V2A Then
          Swap(V1A, V1B);
  l1 := GG[V1B, V1A];
  l2 := GG[V2A, V2B];
  Edge := Clip((l2/2) - (l1/4));
End;

Procedure Bahur;

Var
  I, J : Integer;
  Q : Integer;
  min : Float;
  ppp : Integer;
  pppA, pppB : Integer;
  newn : Integer;
  newe, newp : Float;

Begin
  For I := 1 To M Do
    P[I] := 123456789;
  For I := 1 To GNN[Source] Do
    P[GGG[Source, G[Source, I].V]] := G[Source, I].L / 2;

{  For I := 1 To M Do
    Writeln(I, ' ', P[I]:0:50);}

  For I := 1 To M Do
  Begin
    min := 123456789;
    For J := 1 To M Do
    Begin
      If (Not V[J]) And (P[J] < min) Then
      Begin
        min := P[J];
        ppp := J;
      End;
    End;
    If min > 123456700 Then
      Break;
    V[ppp] := True;

    pppA := G2[ppp].A;
    pppB := G2[ppp].B;

    For Q := 1 To GNN[pppA] Do
    Begin
      newn := GGG[pppA, G[pppA, Q].V];
      newe := Edge(ppp, newn);
      newp := P[ppp] + newe;
      If newp < P[newn] Then
        P[newn] := newp;
    End;
    For Q := 1 To GNN[pppB] Do
    Begin
      newn := GGG[pppB, G[pppB, Q].V];
      newe := Edge(ppp, newn);
      newp := P[ppp] + newe;
      If newp < P[newn] Then
        P[newn] := newp;
    End;
  End;

  min := 123456789;

  For I := 1 To GNN[Dest] Do
  Begin
    newp := P[GGG[Dest, G[Dest, I].V]];
    If newp < min Then
      min := newp;
  End;
  WriteOut(min);
End;

Begin
  ReadIn;
  TestP(Source);
  If V[Dest] = False Then
    WriteOut;
  If M > 11025 Then
  Begin
    BuggyBahur;
    Halt;
  End;
  FillChar(V, 1234*SizeOf(Boolean), 0);
  Bahur;
End.
